| Flutter Impeller |

Public Member Functions | List of all members
impeller::ClipContents Class Referencefinal

`#include <clip_contents.h>`

Inheritance diagram for impeller::ClipContents:

## Public Member Functions
| ClipContents ()
| ~ClipContents ()
void | SetGeometry (const std::shared_ptr< Geometry > &geometry)
void | SetClipOperation (Entity::ClipOperation clip_op)
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
ClipCoverage | GetClipCoverage (const Entity &entity, const std::optional< Rect > &current_clip_coverage) const override
| Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer. More...
bool | ShouldRender (const Entity &entity, const std::optional< Rect > clip_coverage) const override
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
bool | CanInheritOpacity (const Entity &entity) const override
| Whether or not this contents can accept the opacity peephole optimization. More...
void | SetInheritedOpacity (Scalar opacity) override
| Inherit the provided opacity. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
virtual void | PopulateGlyphAtlas (const std::shared_ptr< LazyGlyphAtlas > &lazy_glyph_atlas, Scalar scale)
| Add any text data to the specified lazy atlas. The scale parameter must be used again later when drawing the text. More...
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual bool | IsOpaque () const
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, const std::string &label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...
virtual const FilterContents * | AsFilter () const
| Cast to a filter. Returns `nullptr` if this Contents is not a filter. More...
virtual bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc)
| If possible, applies a color filter to this contents inputs on the CPU. More...

## Additional Inherited Members
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)

## Detailed Description

Definition at line 19 of file clip_contents.h.

## Constructor & Destructor Documentation

## ◆ ClipContents()

impeller::ClipContents::ClipContents | ( |  | ) |
| default

## ◆ ~ClipContents()

impeller::ClipContents::~ClipContents | ( |  | ) |
| default

## Member Function Documentation

## ◆ CanInheritOpacity()

bool impeller::ClipContents::CanInheritOpacity | ( | const Entity & | entity | ) | const
| override virtual

Whether or not this contents can accept the opacity peephole optimization.

By default all contents return false. Contents are responsible for determining whether or not their own geometries intersect in a way that makes accepting opacity impossible. It is always safe to return false, especially if computing overlap would be computationally expensive.

Reimplemented from impeller::Contents.

Definition at line 70 of file clip_contents.cc.

70 {
71 return true;
72 }

## ◆ GetClipCoverage()

Contents::ClipCoverage impeller::ClipContents::GetClipCoverage | ( | const Entity & | entity,
|  | const std::optional< Rect > & | current_clip_coverage
| ) |  | const
| override virtual

Given the current pass space bounding rectangle of the clip buffer, return the expected clip coverage after this draw call. This should only be implemented for contents that may write to the clip buffer.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Reimplemented from impeller::Contents.

Definition at line 37 of file clip_contents.cc.

39 {
40 if (!current_clip_coverage.has_value()) {
41 return {.type = ClipCoverage::Type::kAppend, .coverage = std::nullopt};
42 }
43 switch (clip_op_) {
44 case Entity::ClipOperation::kDifference:
45 // This can be optimized further by considering cases when the bounds of
46 // the current stencil will shrink.
47 return {.type = ClipCoverage::Type::kAppend,
48 .coverage = current_clip_coverage};
49 case Entity::ClipOperation::kIntersect:
50 if (!geometry_) {
51 return {.type = ClipCoverage::Type::kAppend, .coverage = std::nullopt};
52 }
53 auto coverage = geometry_->GetCoverage(entity.GetTransform());
54 if (!coverage.has_value() || !current_clip_coverage.has_value()) {
55 return {.type = ClipCoverage::Type::kAppend, .coverage = std::nullopt};
56 }
57 return {
58 .type = ClipCoverage::Type::kAppend,
59 .coverage = current_clip_coverage->Intersection(coverage.value()),
60 };
61 }
62 FML_UNREACHABLE();
63 }

References impeller::Entity::GetTransform(), impeller::Entity::kDifference, impeller::Entity::kIntersect, and impeller::Contents::ClipCoverage::type.

## ◆ GetCoverage()

std::optional< Rect > impeller::ClipContents::GetCoverage | ( | const Entity & | entity | ) | const
| override virtual

Get the area of the render pass that will be affected when this contents is rendered.

During rendering, coverage coordinates count pixels from the top left corner of the framebuffer.

Returns
  The coverage rectangle. An `std::nullopt` result means that rendering this contents has no effect on the output color.

Implements impeller::Contents.

Definition at line 33 of file clip_contents.cc.

33 {
34 return std::nullopt;
35 };

## ◆ Render()

bool impeller::ClipContents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| override virtual

Implements impeller::Contents.

Definition at line 76 of file clip_contents.cc.

78 {
79 using VS = ClipPipeline::VertexShader;
80
81 VS::FrameInfo info;
82
83 Command cmd;
84
85 auto options = OptionsFromPass(pass);
86 options.blend_mode = BlendMode::kDestination;
87 cmd.stencil_reference = entity.GetClipDepth();
88 options.stencil_compare = CompareFunction::kEqual;
89 options.stencil_operation = StencilOperation::kIncrementClamp;
90
91 if (clip_op_ == Entity::ClipOperation::kDifference) {
92 {
93 DEBUG_COMMAND_INFO(cmd, "Difference Clip (Increment)");
94
95 auto points = Rect::MakeSize(pass.GetRenderTargetSize()).GetPoints();
96 auto vertices =
97 VertexBufferBuilder<VS::PerVertexData>{}
98 .AddVertices({{points[0]}, {points[1]}, {points[2]}, {points[3]}})
99 .CreateVertexBuffer(pass.GetTransientsBuffer());
100 cmd.BindVertices(std::move(vertices));
101
102 info.mvp = pass.GetOrthographicTransform();
103 VS::BindFrameInfo(cmd, pass.GetTransientsBuffer().EmplaceUniform(info));
104
105 options.primitive_type = PrimitiveType::kTriangleStrip;
106 cmd.pipeline = renderer.GetClipPipeline(options);
107 pass.AddCommand(Command(cmd));
108 }
109
110 {
111 DEBUG_COMMAND_INFO(cmd, "Difference Clip (Punch)");
112
113 cmd.stencil_reference = entity.GetClipDepth() + 1;
114 options.stencil_compare = CompareFunction::kEqual;
115 options.stencil_operation = StencilOperation::kDecrementClamp;
116 }
117 } else {
118 DEBUG_COMMAND_INFO(cmd, "Intersect Clip");
119 options.stencil_compare = CompareFunction::kEqual;
120 options.stencil_operation = StencilOperation::kIncrementClamp;
121 }
122
123 auto geometry_result = geometry_->GetPositionBuffer(renderer, entity, pass);
124 options.primitive_type = geometry_result.type;
125 cmd.pipeline = renderer.GetClipPipeline(options);
126
127 auto allocator = renderer.GetContext()->GetResourceAllocator();
128 cmd.BindVertices(std::move(geometry_result.vertex_buffer));
129
130 info.mvp = geometry_result.transform;
131 VS::BindFrameInfo(cmd, pass.GetTransientsBuffer().EmplaceUniform(info));
132
133 pass.AddCommand(std::move(cmd));
134 return true;
135 }

References impeller::RenderPass::AddCommand(), impeller::VertexBufferBuilder< VertexType_, IndexType_ >::AddVertices(), impeller::Command::BindVertices(), DEBUG_COMMAND_INFO, impeller::HostBuffer::EmplaceUniform(), impeller::Entity::GetClipDepth(), impeller::ContentContext::GetClipPipeline(), impeller::ContentContext::GetContext(), impeller::RenderPass::GetOrthographicTransform(), impeller::TRect< T >::GetPoints(), impeller::RenderPass::GetRenderTargetSize(), impeller::RenderPass::GetTransientsBuffer(), impeller::kDecrementClamp, impeller::kDestination, impeller::Entity::kDifference, impeller::kEqual, impeller::kIncrementClamp, impeller::kTriangleStrip, impeller::TRect< Scalar >::MakeSize(), impeller::OptionsFromPass(), impeller::Command::pipeline, and impeller::Command::stencil_reference.

## ◆ SetClipOperation()

void impeller::ClipContents::SetClipOperation | ( | Entity::ClipOperation | clip_op | ) |

Definition at line 29 of file clip_contents.cc.

29 {
30 clip_op_ = clip_op;
31 }

## ◆ SetGeometry()

void impeller::ClipContents::SetGeometry | ( | const std::shared_ptr< Geometry > & | geometry | ) |

Definition at line 25 of file clip_contents.cc.

25 {
26 geometry_ = geometry;
27 }

## ◆ SetInheritedOpacity()

void impeller::ClipContents::SetInheritedOpacity | ( | Scalar | opacity | ) |
| override virtual

Inherit the provided opacity.

       Use of this method is invalid if CanAcceptOpacity returns false.

Reimplemented from impeller::Contents.

Definition at line 74 of file clip_contents.cc.

74 {}

## ◆ ShouldRender()

bool impeller::ClipContents::ShouldRender | ( | const Entity & | entity,
|  | const std::optional< Rect > | clip_coverage
| ) |  | const
| override virtual

Reimplemented from impeller::Contents.

Definition at line 65 of file clip_contents.cc.

66 {
67 return true;
68 }

The documentation for this class was generated from the following files:

- impeller/entity/contents/clip_contents.h
- impeller/entity/contents/clip_contents.cc

impeller::Entity::ClipOperation::kIntersect
@ kIntersect
impeller::OptionsFromPass
ContentContextOptions OptionsFromPass(const RenderPass &pass)
Definition: contents.cc:20
DEBUG_COMMAND_INFO
#define DEBUG_COMMAND_INFO(obj, arg)
Definition: command.h:28
impeller::StencilOperation::kDecrementClamp
@ kDecrementClamp
Decrement the current stencil value by 1. Clamp it to zero.
impeller::Entity::ClipOperation::kDifference
@ kDifference
impeller::CompareFunction::kEqual
@ kEqual
Comparison test passes if new_value == current_value.
impeller::BlendMode::kDestination
@ kDestination
impeller::StencilOperation::kIncrementClamp
@ kIncrementClamp
Increment the current stencil value by 1. Clamp it to the maximum.
impeller::TRect::GetPoints
constexpr std::array< TPoint< T >, 4 > GetPoints() const
Get the points that represent the 4 corners of this rectangle. The order is: Top left,...
Definition: rect.h:247
impeller::PrimitiveType::kTriangleStrip
@ kTriangleStrip
impeller::TRect< Scalar >::MakeSize
constexpr static TRect MakeSize(const TSize< U > &size)
Definition: rect.h:44
impeller::RenderPipelineT::VertexShader
VertexShader_ VertexShader
Definition: pipeline.h:92